package it.unibas.questionari2.controllo;

import it.unibas.questionari2.modello.Questionario;
import it.unibas.questionari2.modello.Risposte;
import it.unibas.questionari2.persistenza.DAOQuestionario;
import it.unibas.questionari2.persistenza.DAORisposte;
import it.unibas.questionari2.persistenza.DAOException;

public class Principale {
    
    public void esegui() {
        Questionario questionario = null;
        Risposte risposte = new Risposte();
        ControlloSecondario controlloSecondario = new ControlloSecondario();
        boolean continua = true;
        while (continua) {
            int scelta = schermoMenuPrincipale();
            if (scelta == 0) {
                continua = false;
            } else if (scelta ==  1) {
                questionario = schermoCaricaQuestionario();
            } else if (scelta == 2) {
                if (questionario == null) {
                    System.out.println("Operazione non consentita. Caricare il questionario prima.");
                } else {
                    controlloSecondario.schermoCompilaQuestionario(risposte, questionario);
                }
            } else if (scelta == 3) {
                    controlloSecondario.schermoValutaQuestionario(questionario, risposte);                
            } else if (scelta == 4) {
                System.out.println("Opzione non implementata");
            } else if (scelta == 5) {
                schermoSalvaRisposte(risposte);                
            } 
        }
    }
    
    private int schermoMenuPrincipale() {
        int scelta;
        System.out.println("---------------------------------------------");
        System.out.println("          Questionari di Valutazione         ");
        System.out.println("---------------------------------------------");
        System.out.println();
        System.out.println("   1. Carica questionario da file");
        System.out.println("   2. Compila questionario");
        System.out.println("   3. Visualizza valutazione questionario");
        System.out.println("   4. Carica risposte da file - non implementata");
        System.out.println("   5. Salva risposte su disco");
        System.out.println();
        System.out.println("   0. Esci");
        System.out.println();
        System.out.print("   Scelta ----> ");
        scelta = it.unibas.utilita.Console.leggiIntero();
        while ((scelta < 0) || (scelta > 5)) {
            System.out.print("   Errore. Ripeti ----> ");
            scelta = it.unibas.utilita.Console.leggiIntero();
        }
        return scelta;
    }
        
    private Questionario schermoCaricaQuestionario() {
        System.out.println("------------------------------------");
        System.out.println("       Caricamento Questionario");
        System.out.println("------------------------------------");
        System.out.print("Inserisci il nome del file --> ");
        String nomeFile = it.unibas.utilita.Console.leggiStringa();
        Questionario questionario = null;
        try {
            questionario = DAOQuestionario.caricaQuestionario(nomeFile);
            System.out.println(" -- Caricamento effettuato -- ");
        } catch (DAOException pe) {
            System.out.println("ERRORE: " + pe);
        }
        return questionario;
    }

    private void schermoSalvaRisposte(Risposte risposte) {
        System.out.println("------------------------------------");
        System.out.println("       Salvataggio Risposte");
        System.out.println("------------------------------------");
        System.out.print("Inserisci il nome del file --> ");
        String nomeFile = it.unibas.utilita.Console.leggiStringa();
        try {
            DAORisposte.salvaRisposte(risposte, nomeFile);
            System.out.println(" -- Salvataggio effettuato -- ");
        } catch (DAOException pe) {
            System.out.println("ERRORE: " + pe);
        }
    }
    
    public static void main(String[] args) {
        Principale p = new Principale();
        p.esegui();
    }
}
