package it.unibas.questionari2.modello;

public class Quesito {
    
    private String id;
    private String idArgomento;
    private String idDifficolta;
    private String soluzione;
    private String domanda;
    private java.util.List listaRisposte = new java.util.ArrayList();
    
    public String getId() {
        return id;
    }
    
    public void setId(String id) {
        this.id = id;
    }
    
    public String getIdArgomento() {
        return idArgomento;
    }
    
    public void setIdArgomento(String idArgomento) {
        this.idArgomento = idArgomento;
    }
    
    public String getSoluzione() {
        return soluzione;
    }
    
    public void setSoluzione(String soluzione) {
        this.soluzione = soluzione;
    }
    
    public String getIdDifficolta() {
        return idDifficolta;
    }
    
    public void setIdDifficolta(String idDifficolta) {
        this.idDifficolta = idDifficolta;
    }
    
    public String getDomanda() {
        return this.domanda;
    }
    
    public void setDomanda(String domanda) {
        this.domanda = domanda;
    }
    
    public int getNumeroRisposte() {
        return this.listaRisposte.size();
    }
    
    public String getRisposta(int i) {
        if (i >= listaRisposte.size()) {
            throw new IndexOutOfBoundsException("Risposta inesistente");
        } 
        return (String)listaRisposte.get(i);
    }
    
    public void addRisposta(String risposta) {
        this.listaRisposte.add(risposta);
    }
           
    public String toString() {
        StringBuffer stringa = new StringBuffer();
        stringa.append(this.getDomanda() + "\n");
        stringa.append("Difficolta: " + this.getIdDifficolta() + "\n");
        for (int i = 0; i < this.getNumeroRisposte(); i++) {
            String lettera = "" + (char)(i + 97);
            stringa.append(lettera + ": " + this.getRisposta(i) + "\n");
        }
        return stringa.toString();
    }
        
    public String toShortString() {
        return "--id: " + id + "--sol: " + getSoluzione() + "--diff: " + getIdDifficolta() +
        "--arg: " + getIdArgomento();
    }

}
