package it.unibas.questionari2.modello;

public class Questionario {
    
    private String id;
    private String disciplina;
    private java.util.HashMap mappaArgomenti = new java.util.HashMap();
    private java.util.HashMap mappaDifficolta = new java.util.HashMap();
    private java.util.List listaQuesiti = new java.util.ArrayList();
    
    public String getId() {
        return this.id;
    }
    
    public void setId(String id) {
        this.id = id;
    }
    
    public String getDisciplina() {
        return disciplina;
    }
    
    public void setDisciplina(String disciplina) {
        this.disciplina = disciplina;
    }
    
    public int getNumeroArgomenti() {
        return mappaArgomenti.size();
    }
    
    public Argomento getArgomento(String id) {
        return (Argomento)mappaArgomenti.get(id);
    }
    
    public void addArgomento(Argomento argomento) {
        mappaArgomenti.put(argomento.getId(), argomento);
    }
    
    public void removeArgomento(String idArgomento) {
        mappaArgomenti.remove(idArgomento);
    }
    
    public int getNumeroDifficolta() {
        return mappaDifficolta.size();
    }
    
    public Difficolta getDifficolta(String id) {
        return (Difficolta)mappaDifficolta.get(id);
    }
    
    public void removeDifficolta(String idDifficolta) {
        mappaDifficolta.remove(idDifficolta);
    }
    
    public void addDifficolta(Difficolta difficolta) {
        mappaDifficolta.put(difficolta.getId(), difficolta);
    }
    
    public int getNumeroQuesiti() {
        return listaQuesiti.size();
    }
    
    public Quesito getQuesito(int i) {
        if (i >= getNumeroQuesiti()) {
            throw new IndexOutOfBoundsException("Quesito inesistente: " + i);
        } 
        return (Quesito)listaQuesiti.get(i);
    }
    
    public void addQuesito(Quesito quesito) {
        listaQuesiti.add(quesito);
    }
    
    public String toString() {
        String risultato = "";
        risultato += "----------------------------------------\n";
        risultato += "  Questionario: " + getId() + "\n";
        risultato += "----------------------------------------\n";
        risultato += stringaArgomenti();
        risultato += stringaDifficolta();
        risultato += stringaQuesiti();
        risultato += "----------------------------------------\n";
        return risultato;
    }
    
    private String stringaArgomenti() {
        String risultato = "  --Argomenti:--\n";
        java.util.Collection argomenti = this.mappaArgomenti.values();
        java.util.Iterator iterator = argomenti.iterator();
        while (iterator.hasNext()) {
            Argomento argomento = (Argomento)iterator.next();
            risultato += "  " + argomento.getId();
        }
        risultato += "\n";
        return risultato;
    }
    
    private String stringaDifficolta() {
        String risultato = "  --Difficolta:--\n";
        java.util.Collection difficoltas = this.mappaDifficolta.values();
        java.util.Iterator iterator = difficoltas.iterator();
        while (iterator.hasNext()) {
            Difficolta difficolta = (Difficolta)iterator.next();
            risultato += "  " + difficolta.getId();
        }
        risultato += "\n";
        return risultato;
    }
    
    private String stringaQuesiti() {
        String risultato = "  --Quesiti:--\n";
        risultato += "  ";
        for (int i = 0; i < listaQuesiti.size(); i++) {
            risultato += ((Quesito)listaQuesiti.get(i)).toString() + "\n";
        }
        risultato += "\n";
        return risultato;
    }
                
}
