package it.unibas.questionari2.modello;

public class Risposte {

    private String idQuestionario = "";
    private java.util.List listaRisposte = new java.util.ArrayList();

    public void setIdQuestionario(String idQuestionario) {
        this.idQuestionario = idQuestionario;
    }
    
    public String getIdQuestionario() {
        return this.idQuestionario;
    }
    
    public int getNumeroRisposte() {
        return this.listaRisposte.size();
    }

    public void addRisposta(String risposta) {
        listaRisposte.add(risposta);
    }

    public void setRisposta(String risposta, int i) {
        if (i >= this.getNumeroRisposte()) {
            throw new IndexOutOfBoundsException("Posizione inesistente");
        }
        listaRisposte.set(i, risposta);
    }

    public String getRisposta(int i) {
        if (i >= this.getNumeroRisposte()) {
            throw new IndexOutOfBoundsException("Posizione inesistente");
        }
        String risposta = (String)listaRisposte.get(i);
        if (risposta != null) {
            return risposta;
        } else {
            return "";
        }
    }

    public String toString() {
        StringBuffer stringa = new StringBuffer();
        stringa.append("--------------------------------------\n");
        stringa.append("         Risposte fornite             \n");
        stringa.append("--------------------------------------\n");
        for (int i = 0; i < this.getNumeroRisposte(); i++) {
            stringa.append("Domanda n. " + i + " - ");
            stringa.append("Risposta data:  " + this.getRisposta(i) + "\n");
        }        
        return stringa.toString();
    }
    
}
