package it.unibas.questionari2.persistenza;

import it.unibas.questionari2.modello.Risposte;

public class DAORisposte {
    

    // Salvataggio
    public static void salvaRisposte(Risposte risposte, String nomeFile) throws DAOException {
        if (risposte == null) {
            throw new DAOException("Le risposte non possono essere nulle");
        }
        org.w3c.dom.Document document = creaDocumento();
        completaRadice(risposte, document);
        aggiungiListaRisposte(risposte, document);
        salvaDOM(document, nomeFile);
        String percorso = DAOUtilita.estraiPercorso(nomeFile);
        DAOUtilita.copiaDTD(percorso);
    }

    private static org.w3c.dom.Document creaDocumento() throws DAOException {
        org.w3c.dom.Document document = null;
        javax.xml.parsers.DocumentBuilderFactory factory = javax.xml.parsers.DocumentBuilderFactory.newInstance();
        factory.setValidating(true);
        try {
            javax.xml.parsers.DocumentBuilder builder = factory.newDocumentBuilder();
            document = builder.newDocument();
            org.w3c.dom.Element radice = (org.w3c.dom.Element)document.createElement("risposte");
            document.appendChild(radice);
        } catch (javax.xml.parsers.ParserConfigurationException pce) {
            System.err.println(pce);
            throw new DAOException(pce);
        } catch (org.w3c.dom.DOMException doe) {
            System.err.println(doe);
            throw new DAOException(doe);
        }
        return document;
    }
    
    private static void completaRadice(Risposte risposte, org.w3c.dom.Document document) {
        org.w3c.dom.Element radice = document.getDocumentElement();
        org.w3c.dom.Attr idQuestionario = document.createAttribute("idquestionario");
        idQuestionario.setValue(risposte.getIdQuestionario());
        radice.setAttributeNode(idQuestionario);
    }
    
    private static void aggiungiListaRisposte(Risposte risposte, org.w3c.dom.Document document) {
        org.w3c.dom.Element radice = document.getDocumentElement();
        org.w3c.dom.Element elementoListaRisposte = document.createElement("listaRisposte");
        radice.appendChild(elementoListaRisposte);
        for (int i = 0; i < risposte.getNumeroRisposte(); i++) {
            aggiungiRisposta(risposte, i, elementoListaRisposte, document);
        }
    }
    
    private static void aggiungiRisposta(Risposte risposte, int i,
    org.w3c.dom.Element elementoListaRisposte,
    org.w3c.dom.Document document) {
        org.w3c.dom.Element elementoRisposta = document.createElement("risposta");
        String risposta = risposte.getRisposta(i);
        org.w3c.dom.Attr attrId = document.createAttribute("id");
        attrId.setValue("r" + i);
        elementoRisposta.setAttributeNode(attrId);
        org.w3c.dom.Text testo = document.createTextNode(risposta);
        elementoRisposta.appendChild(testo);
        elementoListaRisposte.appendChild(elementoRisposta);
    }
    
    
    private static void salvaDOM(org.w3c.dom.Document document, String nomeFile) throws DAOException {
        try {
            java.io.File file = new java.io.File(nomeFile);
            javax.xml.transform.TransformerFactory transformerFactory = javax.xml.transform.TransformerFactory.newInstance();
            javax.xml.transform.Transformer transformer = transformerFactory.newTransformer();
            transformer.setOutputProperty("indent", "yes");
            transformer.setOutputProperty(javax.xml.transform.OutputKeys.DOCTYPE_SYSTEM, "risposte.dtd");
            javax.xml.transform.dom.DOMSource source = new javax.xml.transform.dom.DOMSource(document);
            javax.xml.transform.stream.StreamResult result = new javax.xml.transform.stream.StreamResult(file);
            transformer.transform(source, result);
        } catch (javax.xml.transform.TransformerConfigurationException tce) {
            System.err.println(tce);
            throw new DAOException(tce);
        } catch (javax.xml.transform.TransformerException te) {
            System.err.println(te);
            throw new DAOException(te);
        }
    }

}
