package it.unibas.questionari2.test;

import junit.framework.TestCase;
import it.unibas.questionari2.modello.Questionario;
import it.unibas.questionari2.modello.Quesito;

public class TestQuestionario extends TestCase {
    
    private Questionario questionario1;
    private Questionario questionario2;
    
    protected void setUp() {
        questionario1 = Utilita.creaQuestionario1();
        questionario2 = Utilita.creaQuestionario2();
    }

    protected void tearDown() throws java.lang.Exception {
    }
        
    public void testQuestionario1() {
        assertTrue("n. argomenti", questionario1.getNumeroArgomenti() == 2);
        assertTrue("n. difficolta", questionario1.getNumeroDifficolta() == 3);
        assertTrue("n. quesiti", questionario1.getNumeroQuesiti() == 5);
    }

    public void testQuestionario2() {
        assertTrue("n. argomenti", questionario2.getNumeroArgomenti() == 1);
        assertTrue("n. difficolta", questionario2.getNumeroDifficolta() == 2);
        assertTrue("n. quesiti", questionario2.getNumeroQuesiti() == 1);
    }

    public void testGetQuesito1() {
        Quesito quesito = questionario1.getQuesito(0);
        assertTrue("quesito 0", quesito.getId().equals("cap01"));
        quesito = questionario1.getQuesito(1);
        assertTrue("quesito 1", quesito.getId().equals("cap02"));
        quesito = questionario1.getQuesito(2);
        assertTrue("quesito 2", quesito.getId().equals("cap03"));
        quesito = questionario1.getQuesito(3);
        assertTrue("quesito 3", quesito.getId().equals("naz01"));
        quesito = questionario1.getQuesito(4);
        assertTrue("quesito 4", quesito.getId().equals("naz02"));
    }

    public void testGetQuesito2() {
        try {
            Quesito quesito = questionario1.getQuesito(5);
            fail();
        } catch (Exception e) {
            assertTrue("eccezione", e != null);
        }
    }

    public void testGetQuesito3() {
        Quesito quesito = questionario2.getQuesito(0);
        assertTrue("quesito 0", quesito.getId().equals("cap01"));
    }

    public void testGetQuesito4() {
        try {
            Quesito quesito = questionario2.getQuesito(1);
            fail();
        } catch (Exception e) {
            assertTrue("eccezione", e != null);
        }
    }
}
