package it.unibas.questionari2.test;

import junit.framework.*;
import it.unibas.questionari2.modello.Valutatore;
import it.unibas.questionari2.modello.Questionario;
import it.unibas.questionari2.modello.Risposte;

public class TestValutatore extends TestCase {
    
    private Valutatore valutatore1;
    private Valutatore valutatore2;
    
    protected void setUp() throws java.lang.Exception {
        Questionario questionario1 = Utilita.creaQuestionario1();
        Questionario questionario2 = Utilita.creaQuestionario2();
        Risposte risposte1 = Utilita.creaRisposte1();
        Risposte risposte2 = Utilita.creaRisposte2();        
        valutatore1 = new Valutatore(questionario1, risposte1);
        valutatore2 = new Valutatore(questionario2, risposte2);
    }

    protected void tearDown() throws java.lang.Exception {
    }
    
    public void testValutatore1() {
        assertTrue("numero risposte", valutatore1.getNumeroRisposte() == 5);
        assertTrue("risposta 0", valutatore1.getRisposta(0).equals("a"));
        assertTrue("soluzione 0", valutatore1.getSoluzione(0).equals("a"));
        assertTrue("isEsatta 0", valutatore1.isEsatta(0));
        assertTrue("isNonData 0", !valutatore1.isNonData(0));
        assertTrue("risposta 3", valutatore1.getRisposta(3).equals(""));
        assertTrue("soluzione 3", valutatore1.getSoluzione(3).equals("c"));
        assertTrue("isEsatta 3", !valutatore1.isEsatta(3));
        assertTrue("isNonData 3", valutatore1.isNonData(3));
        assertTrue("risposte esatte", valutatore1.getNumeroRisposteEsatte() == 3);
        assertTrue("risposte non date", valutatore1.getNumeroRisposteNonDate() == 1);
        try {
            valutatore1.getRisposta(5);
            fail();
        } catch (Exception e) {
            assertTrue("risposta 5", e != null);
        }
    }
    
    public void testvalutatore2() {
        assertTrue("numero risposte", valutatore2.getNumeroRisposte() == 1);
        assertTrue("risposta 0", valutatore2.getRisposta(0).equals("d"));
        assertTrue("soluzione 0", valutatore2.getSoluzione(0).equals("a"));
        assertTrue("isEsatta 0", !valutatore2.isEsatta(0));
        assertTrue("isNonData 0", !valutatore2.isNonData(0));
        assertTrue("risposte esatte", valutatore2.getNumeroRisposteEsatte() == 0);
        assertTrue("risposte non date", valutatore2.getNumeroRisposteNonDate() == 0);
        try {
            valutatore2.getRisposta(1);
            fail();
        } catch (Exception e) {
            assertTrue("risposta 1", e != null);
        }
    }
    
}
